% definizione del sistema
A = [0 -1 2; 2 -3 12; 10 -10 -2];
B = [1 2 1]';
C = [1 0 1];
D = 0;
sistc = ss(A,B,C,0);

% Punto 1
ubar = 1
xbar = -inv(A)*B
ybar = C*xbar

disp('Premi un tasto per continuare'); pause

% Punto 2
t = 0:0.01:5;
u = ones(size(t));
x0 = [0 1 1]';      % gli stati si definiscono come vettori colonna
[yl,tl,xl] = initial(sistc,x0,t);
figure(1); plot(tl,xl); grid on
title('Stato - Movimento libero')
figure(2); plot(tl,yl); grid on
title('Uscita - Movimento libero')

% per separare pi istruzioni sulla stessa riga si usa il ;
disp('Premi un tasto per continuare'); pause

% Punto 3
[yf,tf,xf] = step(sistc,t);
figure(1); plot(tf,xf); grid on
title('Stato - Movimento forzato')
figure(2); plot(tf,yf); grid on
title('Uscita - Movimento forzato')

disp('Premi un tasto per continuare'); pause

% Punto 4
[yt,tt,xt] = lsim(sistc,u,t,x0);
figure(1); plot(tt,xt); grid on
title('Stato - Movimento complessivo')
figure(2); plot(tt,yt); grid on
title('Uscita - Movimento complessivo')

disp('Premi un tasto per continuare'); pause

% Punto 5
figure(1)
plot(t,xt)
hold on
plot(t,xbar(1)*ones(size(t)),'k:')
plot(t,xbar(2)*ones(size(t)),'k:')
plot(t,xbar(3)*ones(size(t)),'k:')
title('Stato - Verifica valori di regime')
hold off
figure(2)
plot(t,yt)
hold on
plot(t,ybar*ones(size(t)),'k:')
legend('y(t)','ybar')
title('Uscita - Verifica valori di regime')
hold off
disp('Premi un tasto per continuare'); pause

% Punto 6
% N.B. I due grafici sono praticamente sovrapposti
figure(1)
plot(t,yt,'b',t,yl+yf,'r')
title('Verifica')
errmax = max(abs(yt-(yl+yf)))