% Punto 1 - Definizione dei sistemi
A1 = [-1 -3; 4 -1];
A2 = [ 1 -3; 4 -1];
A3 = [-4 -3; 1  0];
A4 = [ 1  2; 1  0];
B = [1 1]';
C = [1 0];
D = 0;
sistc1 = ss(A1,B,C,D);
sistc2 = ss(A2,B,C,D);
sistc3 = ss(A3,B,C,D);
sistc4 = ss(A4,B,C,D);

% Punto 2
disp('Equilibrio per il sistema 1'); disp(' ')
ubar = 5
xbar = -inv(A1)*B
ybar = C*xbar

disp('Premi un tasto per continuare'); pause

% Punto 3
disp('Movimento libero per il sistema 1'); disp(' ')
t = 0:0.01:10; x0 = [1 1]';
[yl,tl,xl] = initial(sistc1,x0,t);
figure(1); plot(tl,xl); grid on
title('Stato - Movimento libero')
figure(2); plot(tl,yl); grid on
title('Uscita - Movimento libero')

disp('Premi un tasto per continuare'); pause

% Punto 4
disp('Movimenti liberi dello stato nel piano (x1,x2)'); disp(' ')
[y1,t1,x1] = initial(sistc1,x0,t);
[y2,t2,x2] = initial(sistc2,x0,t);
[y3,t3,x3] = initial(sistc3,x0,t);
[y4,t4,x4] = initial(sistc4,x0,t);
figure(1)
plot(x1(:,1),x1(:,2),'b')
hold on
plot(x2(:,1),x2(:,2),'r')
plot(x3(:,1),x3(:,2),'g')
plot(x4(:,1),x4(:,2),'m')
hold off
legend('A1','A2','A3','A4',2)
axis([-2.5 2.5 -2 2])
title('Traiettorie nel piano (x_1,x_2)')
xlabel('x_1')
ylabel('x_2')

disp('Movimenti liberi dell''uscita'); disp(' ')
figure(2)
plot(t,y1,'b',t,y2,'r',t,y3,'g',t,y4,'m')
legend('A1','A2','A3','A4')
axis([0 10 -1.5 2.5])
title('Movimento dell''uscita y(t)')
xlabel('t')
ylabel('y')

disp('Premi un tasto per continuare'); pause

% Punto 6
[ys,ts,xs] = step(sistc1,t);
ys = 5*ys;
figure(1)
plot(ts,ys); grid on
title('Risposta allo scalino')

disp('Premi un tasto per continuare'); pause

% Punto 7
t = 0:0.01:10;
u = sin(2*pi*t);
[y,t,x] = lsim(sistc1,u,t);
figure(1); plot(tl,xl); grid on
title('Stato - Movimento forzato')
figure(2); plot(tl,yl); grid on
title('Uscita - Movimento forzato')